<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-dialog :title="title" :close-on-click-modal="false" draggable width="1200px" height="500px" @close="close"
			append-to-body v-model="visible">
			<el-form :model="inputForm" ref="inputForm" v-loading="loading" :rules="rules"
				:class="method === 'view' ? 'readonly' : ''"
				:disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" label-width="100px"
				@submit.native.prevent>
				<el-row :gutter="26">
					<el-col :span="12">
						<el-form-item label="奖项" prop="name">
							<el-input v-model="inputForm.name" placeholder="请输入奖项"></el-input>
						</el-form-item>
					</el-col>

					<el-col :span="12">
						<el-form-item label="获奖日期" prop="rewardDate">
							<el-date-picker v-model="inputForm.rewardDate" type="date" placeholder="请选择获奖日期"
								style="width: 100%;">
							</el-date-picker>
						</el-form-item>
					</el-col>

					<el-col :span="24">
						<el-form-item label="简述" prop="description">
							<el-input type="textarea" v-model="inputForm.description" placeholder="请输入简述">
							</el-input>
						</el-form-item>
					</el-col>

					<el-col :span="24">
						<el-form-item label="附件" prop="files">
							<UpLoadComponent ref="upLoadComponent"></UpLoadComponent>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<template #footer>
				<span class="dialog-footer">
					<el-button @click="close()" icon="el-icon-circle-close">关闭</el-button>
					<el-button v-if="method === 'edit' || method == 'add'" type="primary" icon="el-icon-circle-check"
						@click="doSubmit()">暂存</el-button>
				</span>
			</template>
		</el-dialog>
	</div>
</template>

<script>
import UpLoadComponent from '@/views/common/UpLoadComponentCardStyle'
import enrollmentRegistrationService from '@/api/human/enrollment/EnrollmentRegistrationService'
export default {
	props: {
		businessId: {
			type: String,
			default: ''
		},
		formReadOnly: {
			type: Boolean,
			default: false
		},
		status: {
			type: String,
			default: ''
		}
	},
	data() {
		return {
			disabled: false,
			title: '',
			method: '',
			visible: false,
			loading: false,
			inputForm: {
				id: "",
				enrollmentRegistrationId: '',
				name: "",       // 奖项
				rewardDate: "",       // 获奖日期
				description: "", // 简述
				files: [],
				status: "",
			},
			keyWatch: '',
			rules: {
				name: [
					{ required: true, message: '请输入语言', trigger: 'blur' }
				],
				rewardDate: [
					{ required: true, message: '请输入获奖日期', trigger: 'blur' }
				],
			},
			fileType: ['jpg', 'jpeg', 'png', 'webp'],

		}
	},
	created() {

	},
	components: {
		UpLoadComponent
	},
	computed: {
		bus: {
			get() {
				return this.businessId
			},
			set(val) {
				this.businessId = val
			}
		},
		name() {
			return this.$store.state.user.name
		},
		userId() {
			return this.$store.state.user.id
		}
	},
	watch: {
		'keyWatch': {
			handler(newVal) {
				if (this.commonJS.isNotEmpty(this.bus)) {
					this.init('', this.bus)
				} else {
					this.$nextTick(() => {
						this.$refs.inputForm.resetFields()
					})
				}
			}
		},
		'loading': {
			handler(newVal) {
				this.$emit('changeLoading', newVal)
			}
		}
	},
	methods: {
		getKeyWatch(keyWatch) {
			this.keyWatch = keyWatch
		},
		init(method, id, reId) {
			this.method = method
			this.inputForm = {
				id: "",
				enrollmentRegistrationId: '',
				name: "",       // 奖项
				rewardDate: "",       // 获奖日期
				description: "", // 简述
				files: [],
				status: "",
			}
			if (method === 'add') {
				this.title = `新增语言能力`
			} else if (method === 'edit') {
				this.title = '修改语言能力'
			} else if (method === 'view') {
				this.title = '查看语言能力'
			}
			this.inputForm.userId = reId
			this.visible = true
			this.loading = true
			this.$nextTick(() => {
				if (id) {
					enrollmentRegistrationService.findRewardInfoById({
						id: id
					}).then(res => {
						this.inputForm = this.recover(this.inputForm, res)
						this.inputForm = JSON.parse(JSON.stringify(this.inputForm))
						if (!this.inputForm.files) {
							this.inputForm.files = []
						}
						this.$refs.upLoadComponent.newUpload(method, this.inputForm.files, 'reward', 50, null, null, null, null, [...this.fileType])
						this.loading = false
					})
				} else {
					this.$refs.upLoadComponent.newUpload(method, this.inputForm.files, 'reward', 50, null, null, null, null, [...this.fileType])
					this.loading = false
				}
			})
		},
		generateFallbackId() {
			const timestamp = Date.now(); // 13位
			const randomPart = Math.floor(Math.random() * 1e6); // 6位随机数
			return String(timestamp) + String(randomPart);  // 返回 19 位字符串
		},
		// 表单提交
		doSubmit() {
			if (this.$refs.upLoadComponent.checkProgress()) {
				return
			}

			this.$refs['inputForm'].validate((valid) => {
				if (valid) {
					this.inputForm.rewardDate = new Date(this.inputForm.rewardDate).getTime(); // 转为时间戳
					this.inputForm.files = this.$refs.upLoadComponent.getDataList()
					// this.$emit("addRewardInfo", JSON.parse(JSON.stringify(this.inputForm)))
					// this.close()
					if (this.inputForm.id && this.inputForm.status != "1" && this.inputForm.status != "4") {
						enrollmentRegistrationService.updateInfoStatus({
							id: this.inputForm.id,
							status: "6",
							type: "8"
						}).then(result => {
							// 暂存状态
							this.inputForm.id = ""
							this.inputForm.status = 1
							enrollmentRegistrationService.saveRewardInfo(this.inputForm).then(res => {
								this.$message.success(res)
								this.$emit("addRewardInfo", this.inputForm.enrollmentRegistrationId)
								this.loading = false
								this.close()
							})
						})
					} else {
						// 暂存状态
						this.inputForm.status = 1
						enrollmentRegistrationService.saveRewardInfo(this.inputForm).then(res => {
							this.$message.success(res)
							this.$emit("addRewardInfo", this.inputForm.enrollmentRegistrationId)
							this.loading = false
							this.close()
						})
					}


				}
			})
		},
		close() {
			this.$refs.upLoadComponent.clearUpload()
			this.$refs.inputForm.resetFields()
			this.visible = false
		},
	}
}
</script>


<style lang="less">
.fileUpload {
	.el-form-item__content {
		width: 100%;
	}
}
</style>
